using APT.BaseData.Domain.Entities.FM;
using APT.BaseData.Domain.Enums.PF;
using APT.Infrastructure.Core;
using APT.MS.Domain.Enums;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace APT.MS.Domain.Entities.SE
{
    /// <summary>
    /// 部门培训计划
    /// </summary>
    [Description("部门培训计划")]
    public class T_SE_DEP_TRAIN_PLAN : MesEntityBase
    {
        /// <summary>
        /// 计划年度
        /// </summary>
        [Description("计划年度")]
        [FormFieldTable]
        [FormFieldEdit]
        public int PLAN_YEAR { get; set; }

        /// <summary>
        /// 发起时间
        /// </summary>
        [Description("发起时间")]
        [FormFieldTable]
        [FormFieldEdit]
        [FormFieldQuery]
        public DateTime? LAUNCH_TIME { get; set; }

        /// <summary>
        /// 发起部门ID
        /// </summary>
        [Description("发起部门")]
        [FormFieldTable]
        [FormFieldEdit]
        [FormFieldQuery]
        [DataFieldForeignKey("Nav_LaunchDepartment")]
        public Guid LAUNCH_DEPARTMENT_ID { get; set; }


        /// <summary>
        /// 导航: 发起部门
        /// </summary>
        [Description("导航: 发起部门")]
        public T_FM_DEPARTMENT Nav_LaunchDepartment { get; set; }


        /// <summary>
        /// 发起人员ID
        /// </summary>
        [Description("发起人员")]
        [FormFieldTable]
        [FormFieldEdit]
        [FormFieldQuery]
        [DataFieldForeignKey("Nav_LaunchUser")]
        public Guid LAUNCH_USER_ID { get; set; }


        /// <summary>
        /// 导航: 发起人员
        /// </summary>
        [Description("导航: 发起人员")]
        public T_FM_USER Nav_LaunchUser { get; set; }

        /// <summary>
        /// 导航: 计划详情
        /// </summary>
        [Description("计划详情")]
        [FormFieldEdit]
        public ICollection<T_SE_DEP_TRAIN_PLAN_DETAIL> Nav_DepTrainPlanDetail { get; set; }

        /// <summary>
        /// 状态
        /// </summary>
        [Description("状态")]
        [EnumName("PFStandardStatus")]
        [FormFieldTable]
        [FormFieldQuery]
        public PFStandardStatus STATUS { get; set; }

        /// <summary>
        /// 触发方式
        /// </summary>
        [Description("触发方式")]
        [EnumName("SEDepTrainPlanTriggerType")]
        [FormFieldTable]
        [FormFieldEdit]
        [FormFieldQuery]
        public SEDepTrainPlanTriggerType TRIGGER_TYPE { get; set; }

        /// <summary>
        /// 安全员ID
        /// </summary>
        [Description("安全员ID")]
        public string SAFE_USER_IDS { get; set; }
        [Description("是否发布")]
        [DataFieldIngore]
        public string PUBLISH { get; set; }

        [DataFieldIngore]
        public int IS_OVERTIME { get; set; }
        /// <summary>
        /// 结束时间
        /// </summary>
        [Description("结束时间")]
        [FormFieldTable]
        [FormFieldEdit]
        [FormFieldQuery]
        public DateTime? END_TIME { get; set; }
    }
}
